﻿using System.Diagnostics;
using System.Windows;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.Wpf;

namespace _9536
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void map_Loaded(object sender, RoutedEventArgs e)
        {
            map.MapUnit = GeographyUnit.DecimalDegree;
            map.MinimumScale = 1;

            var partitionedZoomLevelSet = new ZoomLevelSet(); //make custom zoom levels to zoom in further than default
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[0].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[1].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[2].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[3].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[4].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[5].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[6].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[7].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[8].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[9].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[10].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[11].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[12].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[13].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[14].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[15].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[16].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[17].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[18].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[19].Scale));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[19].Scale / 2));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[19].Scale / 4));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[19].Scale / 6));
            partitionedZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(map.ZoomLevelSet.GetZoomLevels()[19].Scale / 8));

            map.ZoomLevelSet = partitionedZoomLevelSet;

            map.CurrentScaleChanged += Map_CurrentScaleChanged;

            LayerOverlay layerOverlay = new LayerOverlay();
            ShapeFileFeatureLayer shapeFileLayer = new ShapeFileFeatureLayer(@"..\..\AppData\states.shp");
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = WorldStreetsAreaStyles.Military();
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            layerOverlay.Layers.Add(shapeFileLayer);
            map.Overlays.Add(layerOverlay);

            shapeFileLayer.Open();
            map.CurrentExtent = shapeFileLayer.GetBoundingBox();
            map.Refresh();
        }

        private void Map_CurrentScaleChanged(object sender, CurrentScaleChangedWpfMapEventArgs e)
        {
            Debug.WriteLine(e.CurrentScale);
        }
    }
}
